Index: berusky2/src/komat/Berusky3d_light.cpp
===================================================================
--- berusky2.orig/src/komat/Berusky3d_light.cpp
+++ berusky2/src/komat/Berusky3d_light.cpp
@@ -1811,28 +1811,27 @@ inline int sdl_poly_pripocitej_svetla_fa
   EDIT_MESH_POLY * p_poly, LIGHTMAP_FACE * p_lf, int full_light)
 {
   int lnum = p_poly->lightakt;
-  dword *p_data;
-  int ddx;
+  // dword *p_data;
   float suf1, suf2, svf1, svf2;
-  float vzdal, dosah2d, look_max, max_vzdal;
+  float vzdal, dosah2d /*, look_max, max_vzdal*/;
   BOD s;
   DYN_LIGHT *p_dlight;
   int l, sv, su, u = 0;
-  dword r, g, b;
-  dword sr, sg, sb;
-  int nup, nul;                 // pocet pravych/levych pixelu
-  int sup, sul;                 // pocet pravych/levych pixelu
-  int nvp, nvl;                 // pocet pravych/levych pixelu
-  int svp, svl;                 // pocet pravych/levych pixelu
-  int kup, skup;                // fixed pricitaci krok prave/leve strany
-  int kul, skul;                // fixed start prave/leve strany
-  int kvp, skvp;                // fixed pricitaci krok prave/leve strany
-  int kvl, skvl;                // fixed start prave/leve strany
-  int fvzdal;                   // fixed-point 8:24 korekcni hodnota v look-up tabulce
-  int min_u, max_u;
-  int min_v, max_v;
-  int zal, nusu, nvsv;
-  int *p_looksqrt;
+  // dword r, g, b;
+  // dword sr, sg, sb;
+  // int nup, nul;              // pocet pravych/levych pixelu
+  // int sup, sul;              // pocet pravych/levych pixelu
+  // int nvp, nvl;              // pocet pravych/levych pixelu
+  // int svp, svl;              // pocet pravych/levych pixelu
+  // int kup, skup;             // fixed pricitaci krok prave/leve strany
+  // int kul, skul;             // fixed start prave/leve strany
+  // int kvp, skvp;             // fixed pricitaci krok prave/leve strany
+  // int kvl, skvl;             // fixed start prave/leve strany
+  // int fvzdal;                // fixed-point 8:24 korekcni hodnota v look-up tabulce
+  // int min_u, max_u;
+  // int min_v, max_v;
+  // int zal, nusu, nvsv;
+  // int *p_looksqrt;
   int nu, nv;
 
 
@@ -1866,8 +1865,7 @@ inline int sdl_poly_pripocitej_svetla_fa
     return (TRUE);
   }
 
-  ddx = p_lf->p_bmp->x;
-  p_data = p_lf->p_bmp->data;
+  // p_data = p_lf->p_bmp->data;
 
   // udelam to pro kazde svetlo extra zvlaste
   for (l = 0; l < lnum; l++) {
@@ -1875,8 +1873,8 @@ inline int sdl_poly_pripocitej_svetla_fa
     if (!p_dlight->aup)
       continue;
 
-    p_looksqrt = p_dlight->flag & SDL_UTLUM_KVADRATIC ?
-      p_ber->p_looksqrt_quadratic : p_ber->p_looksqrt_linear;
+    // p_looksqrt = p_dlight->flag & SDL_UTLUM_KVADRATIC ?
+    //   p_ber->p_looksqrt_quadratic : p_ber->p_looksqrt_linear;
 
     // 3D bod na rovine
     s.x = p_dlight->tp.x - p_lf->n.x * p_dlight->avzdal;
@@ -1900,110 +1898,110 @@ inline int sdl_poly_pripocitej_svetla_fa
     suf2 = vzdal_bodu_a_primky(&s, &p_lf->s2, &p_lf->s3);
     svf2 = vzdal_bodu_a_primky(&s, &p_lf->s1, &p_lf->s3);
 
-    r = (byte) ftoi(255.0f * p_dlight->dr);
-    g = (byte) ftoi(255.0f * p_dlight->dg);
-    b = (byte) ftoi(255.0f * p_dlight->db);
-    if (p_dlight->flag & SDL_ADD_SUB) {
-      sr = (byte) ftoi(255.0f * p_dlight->sr);
-      sg = (byte) ftoi(255.0f * p_dlight->sg);
-      sb = (byte) ftoi(255.0f * p_dlight->sb);
-    }
-
-    look_max = p_dlight->look_max;
-    if (p_dlight->avzdal >= p_dlight->min) {
-      fvzdal =
-        0x01000000 - ftoi((float) 0x01000000 * ((p_dlight->avzdal -
-            p_dlight->min) / p_dlight->max));
-    }
-    else {
-      fvzdal = 0x01000000;
-    }
+    // r = (byte) ftoi(255.0f * p_dlight->dr);
+    // g = (byte) ftoi(255.0f * p_dlight->dg);
+    // b = (byte) ftoi(255.0f * p_dlight->db);
+    // if (p_dlight->flag & SDL_ADD_SUB) {
+    //   sr = (byte) ftoi(255.0f * p_dlight->sr);
+    //   sg = (byte) ftoi(255.0f * p_dlight->sg);
+    //   sb = (byte) ftoi(255.0f * p_dlight->sb);
+    // }
+
+    // look_max = p_dlight->look_max;
+    // if (p_dlight->avzdal >= p_dlight->min) {
+    //   fvzdal =
+    //     0x01000000 - ftoi((float) 0x01000000 * ((p_dlight->avzdal -
+    //         p_dlight->min) / p_dlight->max));
+    // }
+    // else {
+    //   fvzdal = 0x01000000;
+    // }
 
     dosah2d =
       sqrtf(p_dlight->dosah * p_dlight->dosah -
       p_dlight->avzdal * p_dlight->avzdal);
-    nusu = nu - su;
-    nvsv = nv - sv;
+    // nusu = nu - su;
+    // nvsv = nv - sv;
 
     // Strana U lightmapy
     if (su <= 0) {
       if (suf1 > dosah2d)
         continue;
 
-      min_u = ftoi(look_max * suf1 / dosah2d);
-
-      if (suf2 > dosah2d) {
-        max_u = ftoi(look_max);
-        nup = ftoi(((dosah2d - suf1) / (suf2 - suf1)) * nu);
-      }
-      else {
-        nup = nu;
-        max_u = ftoi(look_max * suf2 / dosah2d);
-      }
-
-      nul = sul = sup = 0;
+      // min_u = ftoi(look_max * suf1 / dosah2d);
 
-      if (nup > 0) {
-        kup = ((max_u - min_u) << 16) / nup;
-        skup = (min_u << 16) - kup;
-      }
+      // if (suf2 > dosah2d) {
+      //   max_u = ftoi(look_max);
+      //   nup = ftoi(((dosah2d - suf1) / (suf2 - suf1)) * nu);
+      // }
+      // else {
+      //   nup = nu;
+      //   max_u = ftoi(look_max * suf2 / dosah2d);
+      // }
+
+      // nul = sul = sup = 0;
+
+      // if (nup > 0) {
+      //   kup = ((max_u - min_u) << 16) / nup;
+      //   skup = (min_u << 16) - kup;
+      // }
     }
     else if (su >= nu - 1) {
 
       if (suf2 > dosah2d)
         continue;
 
-      min_u = ftoi(look_max * suf2 / dosah2d);
-
-      if (suf1 > dosah2d) {
-        max_u = ftoi(look_max);
-        nul = ftoi(((dosah2d - suf2) / (suf1 - suf2)) * nu);
-      }
-      else {
-        nul = nu;
-        max_u = ftoi(look_max * suf1 / dosah2d);
-      }
+      // min_u = ftoi(look_max * suf2 / dosah2d);
 
-      nup = sup = 0;
-      sul = nu - 1;
-
-      if (nul > 0) {
-        kul = ((max_u - min_u) << 16) / nul;
-        skul = (min_u << 16) - kul;
-      }
+      // if (suf1 > dosah2d) {
+      //   max_u = ftoi(look_max);
+      //   nul = ftoi(((dosah2d - suf2) / (suf1 - suf2)) * nu);
+      // }
+      // else {
+      //   nul = nu;
+      //   max_u = ftoi(look_max * suf1 / dosah2d);
+      // }
+
+      // nup = sup = 0;
+      // sul = nu - 1;
+
+      // if (nul > 0) {
+      //   kul = ((max_u - min_u) << 16) / nul;
+      //   skul = (min_u << 16) - kul;
+      // }
 
     }
-    else {
-
-      min_u = MIN_LOOK;
+//     else {
 
-      max_vzdal = (suf2 > suf1) ? suf2 : suf1;
-      max_u =
-        (max_vzdal >
-        dosah2d) ? ftoi(look_max) : ftoi(look_max * max_vzdal / dosah2d);
-
-      // Spocitam pravou stranu -> sf2
-      nup = (suf2 > dosah2d) ? ftoi((dosah2d / suf2) * nusu) : nusu;
-
-      // Leva strana -> su
-      nul = (suf1 > dosah2d) ? ftoi((dosah2d / suf1) * su) : su;
-/*      
-      if(--nul < 0)
-        nul = 0;
-*/
-
-      sup = su;                 // Start prave strany
-      sul = su - 1;             // Start leve strany
+//       min_u = MIN_LOOK;
 
-      if (nup > 0 && nul > 0)
-        kup = kul = (nul > nup) ? (max_u << 16) / nul : (max_u << 16) / nup;
-      else if (nul > nup && nul > 0)
-        kup = kul = (max_u << 16) / nul;
-      else if (nup > 0)
-        kup = kul = (max_u << 16) / nup;
+//       max_vzdal = (suf2 > suf1) ? suf2 : suf1;
+//       max_u =
+//         (max_vzdal >
+//         dosah2d) ? ftoi(look_max) : ftoi(look_max * max_vzdal / dosah2d);
+
+//       // Spocitam pravou stranu -> sf2
+//       nup = (suf2 > dosah2d) ? ftoi((dosah2d / suf2) * nusu) : nusu;
+
+//       // Leva strana -> su
+//       nul = (suf1 > dosah2d) ? ftoi((dosah2d / suf1) * su) : su;
+// /*      
+//       if(--nul < 0)
+//         nul = 0;
+// */
+
+//       sup = su;                 // Start prave strany
+//       sul = su - 1;             // Start leve strany
+
+//       if (nup > 0 && nul > 0)
+//         kup = kul = (nul > nup) ? (max_u << 16) / nul : (max_u << 16) / nup;
+//       else if (nul > nup && nul > 0)
+//         kup = kul = (max_u << 16) / nul;
+//       else if (nup > 0)
+//         kup = kul = (max_u << 16) / nup;
 
-      skul = skup = -kup;
-    }
+//       skul = skup = -kup;
+//     }
 
     /*
        Strana V lightmapy
@@ -2013,80 +2011,80 @@ inline int sdl_poly_pripocitej_svetla_fa
       if (svf1 > dosah2d)
         continue;
 
-      min_v = ftoi(look_max * svf1 / dosah2d);
+      // min_v = ftoi(look_max * svf1 / dosah2d);
 
-      if (svf2 > dosah2d) {
-        max_v = ftoi(look_max);
-        nvp = ftoi(((dosah2d - svf1) / (svf2 - svf1)) * nv);
-      }
-      else {
-        nvp = nv;
-        max_v = ftoi(look_max * svf2 / dosah2d);
-      }
-
-      nvl = svl = svp = 0;
-
-      if (nvp > 0) {
-        kvp = ((max_v - min_v) << 16) / nvp;
-        skvp = (min_v << 16) - kvp;
-      }
+      // if (svf2 > dosah2d) {
+      //   max_v = ftoi(look_max);
+      //   nvp = ftoi(((dosah2d - svf1) / (svf2 - svf1)) * nv);
+      // }
+      // else {
+      //   nvp = nv;
+      //   max_v = ftoi(look_max * svf2 / dosah2d);
+      // }
+
+      // nvl = svl = svp = 0;
+
+      // if (nvp > 0) {
+      //   kvp = ((max_v - min_v) << 16) / nvp;
+      //   skvp = (min_v << 16) - kvp;
+      // }
     }
     else if (sv >= nv - 1) {
 
       if (svf2 > dosah2d)
         continue;
 
-      min_v = ftoi(look_max * svf2 / dosah2d);
-
-      if (svf1 > dosah2d) {
-        max_v = ftoi(look_max);
-        nvl = ftoi(((dosah2d - svf2) / (svf1 - svf2)) * nv);
-      }
-      else {
-        nvl = nv;
-        max_v = ftoi(look_max * svf1 / dosah2d);
-      }
-
-      nvp = svp = 0;
-      svl = nv - 1;
+      // min_v = ftoi(look_max * svf2 / dosah2d);
 
-      if (nvl > 0) {
-        kvl = ((max_v - min_v) << 16) / nvl;
-        skvl = (min_v << 16) - kvl;
-      }
+      // if (svf1 > dosah2d) {
+      //   max_v = ftoi(look_max);
+      //   nvl = ftoi(((dosah2d - svf2) / (svf1 - svf2)) * nv);
+      // }
+      // else {
+      //   nvl = nv;
+      //   max_v = ftoi(look_max * svf1 / dosah2d);
+      // }
+
+      // nvp = svp = 0;
+      // svl = nv - 1;
+
+      // if (nvl > 0) {
+      //   kvl = ((max_v - min_v) << 16) / nvl;
+      //   skvl = (min_v << 16) - kvl;
+      // }
 
     }
-    else {
+//     else {
 
-      min_v = MIN_LOOK;
-
-      max_vzdal = (svf2 > svf1) ? svf2 : svf1;
-      max_v =
-        (max_vzdal >
-        dosah2d) ? ftoi(look_max) : ftoi(look_max * max_vzdal / dosah2d);
-
-      // Spocitam pravou stranu -> sf2
-      nvp = (svf2 > dosah2d) ? ftoi((dosah2d / svf2) * nvsv) : nvsv;
-
-      // Leva strana -> su
-      nvl = (svf1 > dosah2d) ? ftoi((dosah2d / svf1) * sv) : sv;
-/*      
-      if(--nvl < 0)
-        nvl = 0;
-*/
+//       min_v = MIN_LOOK;
 
-      svp = sv;                 // Start prave strany
-      svl = sv - 1;             // Start leve strany
+//       max_vzdal = (svf2 > svf1) ? svf2 : svf1;
+//       max_v =
+//         (max_vzdal >
+//         dosah2d) ? ftoi(look_max) : ftoi(look_max * max_vzdal / dosah2d);
+
+//       // Spocitam pravou stranu -> sf2
+//       nvp = (svf2 > dosah2d) ? ftoi((dosah2d / svf2) * nvsv) : nvsv;
+
+//       // Leva strana -> su
+//       nvl = (svf1 > dosah2d) ? ftoi((dosah2d / svf1) * sv) : sv;
+// /*      
+//       if(--nvl < 0)
+//         nvl = 0;
+// */
+
+//       svp = sv;                 // Start prave strany
+//       svl = sv - 1;             // Start leve strany
+
+//       if (nvp > 0 && nvl > 0)
+//         kvp = kvl = (nvl > nvp) ? (max_v << 16) / nvl : (max_v << 16) / nvp;
+//       else if (nvl > nvp && nvl > 0)
+//         kvp = kvl = (max_v << 16) / nvl;
+//       else if (nvp > 0)
+//         kvp = kvl = (max_v << 16) / nvp;
 
-      if (nvp > 0 && nvl > 0)
-        kvp = kvl = (nvl > nvp) ? (max_v << 16) / nvl : (max_v << 16) / nvp;
-      else if (nvl > nvp && nvl > 0)
-        kvp = kvl = (max_v << 16) / nvl;
-      else if (nvp > 0)
-        kvp = kvl = (max_v << 16) / nvp;
-
-      skvl = skvp = -kvp;
-    }
+//       skvl = skvp = -kvp;
+//     }
 
     // pokud je index po priteni mensi nez 0 -> vezmu maximum !!!
     // pokud je vetsi nez 255 -> kaslu na to    
@@ -2962,22 +2960,26 @@ int sdl_poly_updatuj_lightmap(G_KONFIG *
   return (uploaded);
 }
 
-void sdl_save_lightmap(EDIT_MESH_POLY * p_poly, int p)
-{
-  char pom[200];
-  int l;
-
-  chdir("/home/komat");
-  for (l = 0; l < p_poly->lightnum; l++) {
-    sprintf(pom, "poly%dlight%d.bmp", p, l);
-    bmp_uloz(pom, p_poly->p_light[l]->p_bmp);
-  }
-  for (l = 0; l < p_poly->facenum / 3; l++) {
-    sprintf(pom, "poly%dfacelight%d.bmp", p, l);
-    bmp_uloz(pom, p_poly->p_ind[l].p_bmp);
-  }
+/*
+ * This function is not used, and it chdir's to /home/komat, so I've
+ * removed it.
+ */
+// void sdl_save_lightmap(EDIT_MESH_POLY * p_poly, int p)
+// {
+//   char pom[200];
+//   int l;
+
+//   chdir("/home/komat");
+//   for (l = 0; l < p_poly->lightnum; l++) {
+//     sprintf(pom, "poly%dlight%d.bmp", p, l);
+//     bmp_uloz(pom, p_poly->p_light[l]->p_bmp);
+//   }
+//   for (l = 0; l < p_poly->facenum / 3; l++) {
+//     sprintf(pom, "poly%dfacelight%d.bmp", p, l);
+//     bmp_uloz(pom, p_poly->p_ind[l].p_bmp);
+//   }
 
-}
+// }
 
 inline void sdl_updatuj_poly(G_KONFIG * p_ber, EDIT_MESH_POLY * p_poly,
   int full_light)
Index: berusky2/src/komat/Berusky3d_load.cpp
===================================================================
--- berusky2.orig/src/komat/Berusky3d_load.cpp
+++ berusky2/src/komat/Berusky3d_load.cpp
@@ -299,7 +299,11 @@ int ber_nahraj_materialy(G_KONFIG * p_be
   strcpy(pom, p_jmeno);
   zamen_koncovku(pom, KONCOVKA_MATERIAL);
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    kprintf(1, "Unable to change directory to %s", p_dir);
+    return (FALSE);
+  }
+
   if (!lo_nahraj_materialy(p_ber->p_mat, MAX_CELKEM_MATERIALU, p_ber->p_text,
       MAX_CELKEM_TEXTUR, pom)) {
     kprintf(1, "Unable to load materials %s", p_jmeno);
@@ -326,8 +330,11 @@ void ber_materialy_rozkopiruj(G_KONFIG *
       mat = p_mesh->p_mat[i];
       p_mat = p_imat[mat];
       if (p_mat->flag & MAT_ANIM_FRAME) {
+	int ret;
+
         if (restart) {
-          sprintf(pom, "%s_%d", p_mat->jmeno, i);
+          ret = snprintf(pom, sizeof(pom), "%s_%d", p_mat->jmeno, i);
+	  assert(ret < (int) sizeof(pom));
           mnew = lo_najdi_material(p_ber->p_mat, MAX_CELKEM_MATERIALU, pom);
           assert(mnew != K_CHYBA);
           p_mesh->p_mat[i] = mnew;
@@ -339,7 +346,10 @@ void ber_materialy_rozkopiruj(G_KONFIG *
 
           p_imat[mnew] = kopiruj_material(p_mat);
           p_mesh->p_mat[i] = mnew;
-          sprintf(p_imat[mnew]->jmeno, "%s_%d", p_mat->jmeno, i);
+          ret = snprintf(p_imat[mnew]->jmeno,
+			 sizeof(p_imat[mnew]->jmeno),
+			 "%s_%d", p_mat->jmeno, i);
+	  assert(ret < (int) sizeof(p_imat[mnew]->jmeno));
         }
       }
     }
@@ -350,7 +360,8 @@ void ber_materialy_rozkopiruj(G_KONFIG *
 */
 bool ber_nahraj_mesh(G_KONFIG * p_ber, char *p_jmeno, GAME_MESH_OLD ** p_mesh, int json_export)
 {
-  chdir((p_ber->dir.out_dir));
+  if (chdir(p_ber->dir.out_dir))
+    return (FALSE);
   p_mesh[0] = lo_nahraj_mesh(p_ber->p_mat, MAX_CELKEM_MATERIALU, p_ber->p_text,
                              MAX_CELKEM_TEXTUR, p_jmeno, TRUE, 
                              p_ber->conf_extra_light_vertex, json_export);
@@ -588,7 +599,8 @@ int ber_nahraj_scenu(G_KONFIG * p_ber, c
   strcpy(file, p_jmeno);
   zamen_koncovku(file, KONCOVKA_SCENY);
 
-  chdir((p_dir));
+  if (chdir(p_dir))
+    return (FALSE);
 
   kprintf(1, "           - Load project....");
   if (lo_nahraj_projekt(p_ber->p_mat, MAX_CELKEM_MATERIALU,
@@ -722,7 +734,8 @@ void ber_nahraj_poly(G_KONFIG * p_ber, c
   char file[200];
   int i;
 
-  chdir((p_dir));
+  if (chdir(p_dir))
+    return;
   strcpy(file, p_jmeno);
   zamen_koncovku(file, ".ply");
 
@@ -773,8 +786,10 @@ void ber_nahraj_lightmap(G_KONFIG * p_be
   char pom[200];
   KFILE *f;
   int i, r, loaded;
+  int ret;
 
-  chdir(p_dir);
+  if (chdir(p_dir))
+    return;
   strcpy(pom, p_jmeno);
   zamen_koncovku(pom, KONCOVKA_LIGHTMAPY);
 
@@ -789,7 +804,10 @@ void ber_nahraj_lightmap(G_KONFIG * p_be
     while (!keof(f)) {
       if (kread(&i, sizeof(i), 1, f)) {
         assert(i >= 0 && i < MAX_RAY_TEXTUR);
-        sprintf(p_ber->p_lightmap[i].jmeno, "%s_lp%.3d.bmp", pom, i);
+        ret = snprintf(p_ber->p_lightmap[i].jmeno,
+		       sizeof(p_ber->p_lightmap[i].jmeno),
+		       "%s_lp%.3d.bmp", pom, i);
+	assert(ret < (int) sizeof(p_ber->p_lightmap[i].jmeno));
         kprintf(TRUE, "Lightmap %s...", p_ber->p_lightmap[i].jmeno);
         r = txt_nahraj_lightmapu_z_bmp(NULL, f, p_ber->p_lightmap + i, TRUE);
         assert(r);
@@ -800,7 +818,10 @@ void ber_nahraj_lightmap(G_KONFIG * p_be
   }
   else {                        // stara verze lightmap
     for (i = 0; i < MAX_RAY_TEXTUR; i++) {
-      sprintf(p_ber->p_lightmap[i].jmeno, "%s\\%s_lp%.3d.bmp", p_dir, pom, i);
+      ret = snprintf(p_ber->p_lightmap[i].jmeno,
+		     sizeof(p_ber->p_lightmap[i].jmeno),
+		     "%s\\%s_lp%.3d.bmp", p_dir, pom, i);
+      assert(ret < (int) sizeof(p_ber->p_lightmap[i].jmeno));
       if (efile(p_ber->p_lightmap[i].jmeno)) {
         kprintf(TRUE, "Lightmap %s...", p_ber->p_lightmap[i].jmeno);
         txt_nahraj_lightmapu_z_bmp(p_ber->p_lightmap[i].jmeno, NULL,
Index: berusky2/src/komat/Kdtree.cpp
===================================================================
--- berusky2.orig/src/komat/Kdtree.cpp
+++ berusky2/src/komat/Kdtree.cpp
@@ -492,7 +492,7 @@ void kd_strom_vyrob(EDIT_MESH_POLY * p_u
   if (num || kontnum)
     kd_strom_vyrob_rec(p_poly, num, p_kont, kontnum, p_prvni, 1);
   else
-    memset(p_prvni, 0, sizeof(p_prvni[0]));
+    memset((void *) p_prvni, 0, sizeof(p_prvni[0]));
 
   p_prvni->cislo = kd_hloubka_stromu++;
 }
Index: berusky2/src/komat/Keyframe.cpp
===================================================================
--- berusky2.orig/src/komat/Keyframe.cpp
+++ berusky2/src/komat/Keyframe.cpp
@@ -1487,7 +1487,7 @@ HIERARCHY_TRACK_INFO *key_tri_vyrob_indi
   int poskey, int rotkey, int scalekey)
 {
 
-  memset(p_hir, 0, sizeof(p_hir[0]));
+  memset((void *) p_hir, 0, sizeof(p_hir[0]));
 
   // pozicni klice
   if ((p_hir->pos_keys = poskey)) {
@@ -2094,7 +2094,7 @@ SIMPLE_TRACK_INFO *key_tri_to_sim_indir(
   int i, endtime;
 
   // prevedu hlavni track
-  memset(p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
+  memset((void *) p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
 
   p_sim->keynum = calc_keynum(p_track->endtime);
 
@@ -2153,7 +2153,7 @@ SIMPLE_TRACK_INFO *key_tri_to_sim_indir_
   int i, keynum, endtime;
 
   // prevedu hlavni track
-  memset(p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
+  memset((void *) p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
 
   keynum = p_sim->keynum = calc_keynum(p_track->endtime);
   keynum--;
@@ -2251,7 +2251,10 @@ void key_sim_uloz(SIMPLE_TRACK_INFO * p_
   int i;
   int loop = p_sim->flag & GK_LOOP;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return;
+  }
 
   if (!(f = fopen(p_file, "w"))) {
     ddw("File %s Line %d Chyba otevreni souboru '%s' v %s", __FILE__,
@@ -2294,7 +2297,11 @@ int key_sim_nahraj(APAK_HANDLE * pHandle
   char **p_line;
   int l, lmax;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (FALSE);
+  }
+
   if (!(f = kopen(pHandle, p_file, "r"))) {
     kprintf(TRUE, "File %s Line %d Chyba otevreni souboru '%s' v %s",
       __FILE__, __LINE__, p_file, (p_dir));
@@ -2461,7 +2468,11 @@ int key_sim_nahraj_extended(EDIT_KONTEJN
   int i, objektu = 0, stop, ob, float_scale = FALSE;
   size_ptr end;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (FALSE);
+  }
+
   if (!(f = fopen(p_file, "r"))) {
     ddw("File %s Line %d Chyba otevreni souboru '%s' v %s", __FILE__,
       __LINE__, p_file, (p_dir));
@@ -2504,7 +2515,7 @@ int key_sim_nahraj_extended(EDIT_KONTEJN
 
     p_track = p_track_list[akt_track++] =
       (HIERARCHY_TRACK_INFO *) alloca(sizeof(p_track[0]));
-    memset(p_track, 0, sizeof(p_track[0]));
+    memset((void *) p_track, 0, sizeof(p_track[0]));
 
     /* reset pivot-pointu
      */
@@ -2874,7 +2885,7 @@ typedef struct _HIERARCHY_SIM {
 void key_sim_root_to_sim_indir(HIERARCHY_SIM * p_root,
   SIMPLE_TRACK_INFO * p_sim)
 {
-  memset(p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
+  memset((void *) p_sim, 0, sizeof(SIMPLE_TRACK_INFO));
 
   p_sim->flag = p_root->flag;
   p_sim->keynum = p_root->keynum;
@@ -3058,7 +3069,10 @@ int key_kamera_uloz(KAMERA_TRACK_INFO *
   int i, keynum;
   int p, t, r, fv;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (FALSE);
+  }
 
   if (!(f = fopen(p_file, "w"))) {
     ddw("File %s Line %d Chyba otevreni souboru '%s' v %s", __FILE__,
@@ -3132,8 +3146,11 @@ int key_kamera_nahraj(KAMERA_TRACK_INFO
   char **p_line;
   int l, lmax;
 
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (FALSE);
+  }
 
-  chdir((p_dir));
   if (!(f = kopen(pHandle, p_file, "r"))) {
     kprintf(TRUE, "File %s Line %d Chyba otevreni souboru '%s' v %s",
       __FILE__, __LINE__, p_file, (p_dir));
@@ -3449,7 +3466,11 @@ ANIM_TEXT *key_text_nahraj(char *p_file,
   int p, r, s, v, fr;
   float uhel;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (NULL);
+  }
+
   if (!(f = fopen(p_file, "r"))) {
     ddw("File %s Line %d Chyba otevreni souboru '%s' v %s", 
         __FILE__, __LINE__, p_file, (p_dir));
@@ -3560,7 +3581,10 @@ int key_text_uloz(ANIM_TEXT * p_track, c
   int keynum;
   dword time;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Unable to change directory to %s");
+    return (FALSE);
+  }
 
   if (!(f = fopen(p_file, "w"))) {
     ddw("File %s Line %d Chyba otevreni souboru '%s' v %s", __FILE__,
Index: berusky2/src/komat/Load.cpp
===================================================================
--- berusky2.orig/src/komat/Load.cpp
+++ berusky2/src/komat/Load.cpp
@@ -16,14 +16,14 @@ template < class T > void vyrob_pole(T *
 {
   if (!(*p_dst = (T *) mmalloc(sizeof(*p_dst[0]) * num)))
     chyba("Pamet");
-  memset(*p_dst, 0, sizeof(*p_dst[0]) * num);
+  memset((void *) *p_dst, 0, sizeof(*p_dst[0]) * num);
 }
 
 template < class T > void vyrob_pole_abs(T ** p_dst, int num)
 {
   if (!(*p_dst = (T *) mmalloc(sizeof(byte) * num)))
     chyba("Pamet");
-  memset(*p_dst, 0, sizeof(byte) * num);
+  memset((void *) *p_dst, 0, sizeof(byte) * num);
 }
 
 /*
@@ -426,7 +426,12 @@ EDIT_OBJEKT *slep_objekty(EDIT_OBJEKT *
     strcpy(p_obj->jmeno, p_obj1->jmeno);
   }
   else {
-    sprintf(p_obj->jmeno, "%s_%s", p_obj1->jmeno, p_obj2->jmeno);
+    if (snprintf(p_obj->jmeno, sizeof(p_obj->jmeno),
+		 "%s_%s", p_obj1->jmeno, p_obj2->jmeno) >=
+	(int) sizeof(p_obj->jmeno)) {
+      zrus_objekt(&p_obj);
+      return (NULL);
+    }
   }
 
   assert(strlen(p_obj->jmeno) < MAX_JMENO);
@@ -474,7 +479,7 @@ EDIT_KONTEJNER *vyrob_kontejner(void)
   if ((p_kont = (EDIT_KONTEJNER *) mmalloc(sizeof(EDIT_KONTEJNER))) == NULL)
     chyba("pamet!");
 
-  memset(p_kont, 0, sizeof(p_kont[0]));
+  memset((void *) p_kont, 0, sizeof(p_kont[0]));
   p_kont->max_objektu = MAX_KONT_OBJEKTU;
   p_kont->kreslit = 1;
   p_kont->prvek = K_CHYBA;
@@ -993,7 +998,7 @@ EDIT_MATERIAL *vyrob_material(void)
   if ((p_mat = (EDIT_MATERIAL *) mmalloc(sizeof(EDIT_MATERIAL))) == NULL) {
     chyba("pamet");
   }
-  memset(p_mat, 0, sizeof(EDIT_MATERIAL));
+  memset((void *) p_mat, 0, sizeof(EDIT_MATERIAL));
 
   p_mat->dxmat.diffuse_r = 1.0f;
   p_mat->dxmat.diffuse_g = 1.0f;
@@ -1259,7 +1264,7 @@ GAME_MESH_DATA *kopiruj_mesh_data(GAME_M
     p_ldd = p_desc->p_ldlight;
     while (p_lds) {
       p_ldd->p_next = (DYN_LIGHT *) mmalloc(sizeof(p_ldd->p_next[0]));
-      memcpy(p_ldd->p_next, p_lss, sizeof(p_lds[0]));
+      memcpy((void *) p_ldd->p_next, p_lss, sizeof(p_lds[0]));
       p_lds = p_lds->p_next;
       p_ldd = p_ldd->p_next;
     }
@@ -1933,7 +1938,7 @@ GAME_MESH_OLD *vyrob_mesh(int objektu, G
   if ((p_mesh = (GAME_MESH_OLD *) mmalloc(sizeof(p_mesh[0]))) == NULL) {
     chyba("pamet");
   }
-  memset(p_mesh, 0, sizeof(p_mesh[0]));
+  memset((void *) p_mesh, 0, sizeof(p_mesh[0]));
 
   p_mesh->p_data = (p_data) ? p_data : vyrob_mesh_data();
   p_mesh->objektu = objektu;
@@ -2644,7 +2649,11 @@ void lo_vyrob_animaci_list(EDIT_MATERIAL
   int linenum;
   int first_text = 1, i, t, akt, pos, alfa, a;
 
-  chdir((p_dir));
+  if (chdir(p_dir)) {
+    ddw("Cannot change directory to %s", p_dir);
+    assert(0);
+    return;
+  }
 
   if ((f = fopen(p_list, "r")) == NULL) {
     ddw("Nemuzu otevrit soubor %s", p_list);
@@ -2657,9 +2666,14 @@ void lo_vyrob_animaci_list(EDIT_MATERIAL
   // Prekopiruj list
   strcpy(p_amat->jmeno, p_list);
 
+  if (fgets(line, 200, f) == NULL) {
+    ddw("Cannot read %s", p_list);
+    assert(0);
+    return;
+  }
+
   // nahraj informace o frame animaci
   if (komplet == ANIM_LOAD_ALL || komplet == ANIM_LOAD_FRAME) {
-    fgets(line, 200, f);
     sscanf(line, "FRAME %d %d %d", &akt, &p_amat->frameakt, &alfa);
     if (akt) {
       p_mat->flag =
@@ -2667,16 +2681,16 @@ void lo_vyrob_animaci_list(EDIT_MATERIAL
       //p_mat->flag = alfa ? p_mat->flag|MAT_ALFA_FAKTOR : p_mat->flag&~MAT_ALFA_FAKTOR;
     }
   }
-  else
-    fgets(line, 200, f);
+
+  if (fgets(line, 200, f) == NULL) {
+    ddw("Cannot read %s", p_list);
+    assert(0);
+    return;
+  }
 
   // nahraj informace o posunu
-  if (komplet == ANIM_LOAD_ALL || komplet == ANIM_LOAD_POSUN) {
-    fgets(line, 200, f);
+  if (komplet == ANIM_LOAD_ALL || komplet == ANIM_LOAD_POSUN)
     sscanf(line, "POSUN %d\n", &pos);
-  }
-  else
-    fgets(line, 200, f);
 
   // pokud je pozadavek na load frame animace
   if (komplet == ANIM_LOAD_ALL || komplet == ANIM_LOAD_FRAME) {
@@ -2692,11 +2706,19 @@ void lo_vyrob_animaci_list(EDIT_MATERIAL
       (ANIM_FRAME *) mmalloc(sizeof(ANIM_FRAME) * p_amat->framenum);
 
     fseek(f, 0, SEEK_SET);
-    fgets(line, 200, f);
-    fgets(line, 200, f);
+    if (fgets(line, 200, f) == NULL || fgets(line, 200, f) == NULL) {
+      ddw("Cannot read %s", p_list);
+      assert(0);
+      return;
+    }
 
     for (i = 0; i < p_amat->framenum; i++) {
-      fgets(line, 200, f);      // nacti jmeno souboru
+      // nacti jmeno souboru
+      if (fgets(line, 200, f) == NULL) {
+	ddw("Cannot read %s", p_list);
+	assert(0);
+	return;
+      }
 
       if ((p_pom = strchr(line, '\n')))
         *p_pom = 0;
@@ -2916,7 +2938,7 @@ EDIT_MESH_POLY *edit_to_poly_indir(EDIT_
   p_obj = p_kont->p_obj[0];
   assert(p_obj);
 
-  memset(p_poly, 0, sizeof(*p_poly));
+  memset((void *) p_poly, 0, sizeof(*p_poly));
 
   strcpy(p_poly->jmeno, p_kont->jmeno);
 
@@ -3178,6 +3200,8 @@ EDIT_MESH_POLY *lo_nahraj_poly_list(char
     lo_poly_nahraj_indir(f, p_poly + i, p_light);
 
     if (p_poly[i].m1flag & MAT_ANIM_FRAME) {
+      int ret;
+
       // animovany material u poly-listu skopiruju
       mat = lo_najdi_material(p_mat, matnum, material);
       assert(mat != K_CHYBA);
@@ -3186,7 +3210,9 @@ EDIT_MESH_POLY *lo_nahraj_poly_list(char
       assert(mn != K_CHYBA);
 
       p_mat[mn] = kopiruj_material(p_mat[mat]);
-      sprintf(p_mat[mn]->jmeno, "%s_ak%d", p_mat[mat]->jmeno, mn);
+      ret = snprintf(p_mat[mn]->jmeno, sizeof(p_mat[mn]->jmeno),
+		     "%s_ak%d", p_mat[mat]->jmeno, mn);
+      assert(ret < (int) sizeof(p_mat[mn]->jmeno));
     }
     else {
       p_poly[i].material = lo_najdi_material(p_mat, matnum, material);
@@ -3424,10 +3450,8 @@ int lo_uloz_materialy(EDIT_MATERIAL ** p
   strcpy(file, p_file);
   zamen_koncovku(file, KONCOVKA_MATERIAL);
 
-  chdir((p_dir));
-  if ((f = ffopen(file, "wb")) == NULL) {
+  if (chdir(p_dir) || (f = ffopen(file, "wb")) == NULL)
     return (FALSE);
-  }
 
   for (i = 0; i < max_mat; i++) {
     if (p_mat[i])
@@ -3446,10 +3470,8 @@ int lo_uloz_material(EDIT_MATERIAL * p_m
   strcpy(file, p_file);
   zamen_koncovku(file, KONCOVKA_MATERIAL);
 
-  chdir((p_dir));
-  if ((f = ffopen(file, "wb")) == NULL) {
+  if (chdir (p_dir) || (f = ffopen(file, "wb")) == NULL)
     return (FALSE);
-  }
 
   lo_uloz_material_chunk(f, p_mat);
 
@@ -3470,10 +3492,8 @@ int lo_uloz_materialy_pouzite(EDIT_MATER
   strcpy(file, p_file);
   zamen_koncovku(file, KONCOVKA_MATERIAL);
 
-  chdir((p_dir));
-  if ((f = ffopen(file, "wb")) == NULL) {
+  if (chdir(p_dir) || (f = ffopen(file, "wb")) == NULL)
     return (FALSE);
-  }
 
   for (i = 0; i < max_mat; i++) {
     if (p_mat[i] && p_mat[i]->flag & (MAT_POUZITY | MAT_SYSTEM)) {
@@ -4274,17 +4294,17 @@ void lo_vymaz_svetla_ze_sceny(EDIT_KONTE
 
   while (p_slight) {
     p_snext = p_slight->p_next;
-    memset(p_slight, 0, sizeof(p_slight[0]));
+    memset((void *) p_slight, 0, sizeof(p_slight[0]));
     p_slight = p_snext;
   }
   while (p_dlight) {
     p_dnext = p_dlight->p_next;
-    memset(p_dlight, 0, sizeof(p_dlight[0]));
+    memset((void *) p_dlight, 0, sizeof(p_dlight[0]));
     p_dlight = p_dnext;
   }
   while (p_elight) {
     p_enext = p_elight->p_next;
-    memset(p_elight, 0, sizeof(p_elight[0]));
+    memset((void *) p_elight, 0, sizeof(p_elight[0]));
     p_elight = p_enext;
   }
 }
@@ -4319,12 +4339,12 @@ void lo_vymaz_svetla_ze_sceny_mesh(GAME_
 
   while (p_dlight) {
     p_dnext = p_dlight->p_next;
-    memset(p_dlight, 0, sizeof(p_dlight[0]));
+    memset((void *) p_dlight, 0, sizeof(p_dlight[0]));
     p_dlight = p_dnext;
   }
   while (p_elight) {
     p_enext = p_elight->p_next;
-    memset(p_elight, 0, sizeof(p_elight[0]));
+    memset((void *) p_elight, 0, sizeof(p_elight[0]));
     p_elight = p_enext;
   }
 }
Index: berusky2/src/komat/Load_chunks.cpp
===================================================================
--- berusky2.orig/src/komat/Load_chunks.cpp
+++ berusky2/src/komat/Load_chunks.cpp
@@ -2995,7 +2995,7 @@ int lo_chunk_load_flare(FFILE f, OUT_CHU
       return (FALSE);
     }
     p_flare = p_flarelist + i;
-    memset(p_flare, 0, sizeof(p_flare[0]));
+    memset((void *) p_flare, 0, sizeof(p_flare[0]));
     ffread(&p_flare->p, sizeof(BOD), 1, f);
     ffread(&p_flare->r, sizeof(float), 4, f);
     ffread(&p_flare->dx, sizeof(float), 2, f);
@@ -3041,7 +3041,7 @@ int lo_chunk_load_flare_ext(FFILE f, OUT
       return (FALSE);
     }
     p_flare = p_flarelist + i;
-    memset(p_flare, 0, sizeof(p_flare[0]));
+    memset((void *) p_flare, 0, sizeof(p_flare[0]));
     ffread(&p_flare->p, sizeof(BOD), 1, f);
     ffread(&p_flare->r, sizeof(float), 4, f);
     ffread(&p_flare->dx, sizeof(float), 2, f);
@@ -3410,7 +3410,7 @@ int lo_chunk_load_static_light(FFILE f,
 
   if (p_lightlist && p_ch->typ == CHUNK_STATIC_LIGHT) {
 
-    memset(&light, 0, sizeof(light));
+    memset((void *) &light, 0, sizeof(light));
 
     ffread(&light.akt, sizeof(light.akt), 1, f);
     str_read(light.jmeno, f);
@@ -4792,7 +4792,7 @@ int lo_chunk_load_sim_node(FFILE f, SIMP
   if (p_sim && (ch.typ == CHUNK_SIM_NODE || ch.typ == CHUNK_SIM_NODE_EXT
       || ch.typ == CHUNK_SIM_NODE_EXT2)) {
 
-    memset(p_sim, 0, sizeof(p_sim[0]));
+    memset((void *) p_sim, 0, sizeof(p_sim[0]));
 
     ffread(&p_sim->Objekt_ID, sizeof(p_sim->Objekt_ID), 1, f);
     ffread(&p_sim->flag, sizeof(p_sim->flag), 1, f);
